#include <MatchMatrix.h>
#include <PBS_Server.h>
#include <unistd.h>
#include <JobDeployment.h>
#include <StopWatch.h>

// *****************************************************************************
// * This variable identifies this application to the logging methods.
// *****************************************************************************
const char * msg_daemonname = SetLogLocal("testMatrix");


StopWatch stopwatch;

int main (int argc, char ** argv)
{
int    connID = -1;
FILE * fp  = NULL;
char   buf[1024];

if(argc>1)
	{
	connID = pbs_connect(argv[1]);
	}
else if	((fp = fopen("/usr/spool/PBS/server_name", "r"))!=NULL &&
	(fgets(buf, 1024, fp)!=NULL))
	{
	// Remove the trailing carriage return
	char * ptr;
	if((ptr = strchr(buf, '\n'))!=NULL) *ptr = 0;

	connID = pbs_connect(buf);
	fclose(fp);
	}

if(connID<=0)
	{
	fprintf(stdout, "Error: Server name unspecified or not valid\n");
	return 0;
	}

MatchMatrix matrix;
PBS_Server  server( connID );
PBS_Job **  jobs = server.getJobsByState(PBS_Job::QUEUED);
size_t      jobCnt = 0;


for(jobCnt=0; jobs && jobs[jobCnt]; jobCnt++);

size_t qIter = 1000;
size_t cIter = 10;

JobDeployment * scheduled = NULL;

matrix.startCycle(server);
scheduled = matrix.processJobs(jobs, jobCnt, 0);
while(scheduled!=NULL)
	{
	scheduled->asciiDump(stdout, "\t\t=> ");
	scheduled = scheduled->getNext();
	}
matrix.endCycle();
	
return 0;
}
